//+-----------------------------------------------------------------------------------+
//|                                         ZZ_All Quotings Exchange+Metals 0-0040.mq4|
//|                                         Copyright  Zhunko                        |
//|27.03.2007                               MF ZHUNKO zhunko@mail.ru                  |
//+-----------------------------------------------------------------------------------+
//|          .                     |
//|     ""  .                                       |
//|      4 ->->->        |
//|     .          |
//|  .    4   .|
//+-----------------------------------------------------------------------------------+
//|                                .                              |
//| 1.   ZZ_All Quotings Exchange+Metals 0-0020  28.03.2007.       |
//| 1.1.       .                           |
//| 1.2.       .                        |
//|       : ZZ_All_Quotings_Exchange_InCorrect.txt;                       |
//|     : ZZ_All_Quotings_Metals_InCorrect.txt.                                |
//| 2.   ZZ_All Quotings Exchange+Metals 0-0030  31.03.2007.       |
//| 2.1.   .                                            |
//| 2.2.    .                                    |
//| 2.3.     .                              |
//| 2.4.      .                        |
//| 3.   ZZ_All Quotings Exchange+Metals 0-0040  31.03.2007.       |
//| 3.1.  .         |
//|      ,      .               |
//+-----------------------------------------------------------------------------------+
#property copyright "Copyright  2007 Zhunko"
#property link      "zhunko@mail.ru"
#include <WinUser32.mqh>
//---- .------------------------------------------
//----.--------------------------------------------------------
int    ArrayTimFram_time[12] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200, 40320, 41760, 44640};
string ArrayCurrency[] = {"AUD", "ALL", "ARS", "BRL", "BWP", "CAD", "CCK", "CHF", "CLP", "CNY", "COP", "CVE", "CYP", "CZK", "DKK", "DOP", "DZD", "EGP", "EUR", "GBP",
                          "GEL", "GIP", "HKD", "HRK", "HUF", "IDR", "IRR", "ILS", "INR", "ISK", "JPY", "KRW", "LBR", "LSL", "LTL", "LVL", "MAD", "MTL", "MXN", "MYR",
                          "NOK", "NPR", "NZD", "PHP", "PKR", "PLN", "QAR", "RUB", "RUR", "SAR", "SEK", "SGD", "SKK", "THB", "TND", "TRY", "TWD", "UAH", "USD", "XOF",
                          "ZAR", "ZMK"};
string ArrayMetals[]   = {"GOLD", "PALL", "PALLADIUM", "PLAT", "PLATINUM", "SILVER", "XAG", "XAU"};
string ArrayTimfram_str[9] = {"M1 ", "M5 ", "M15", "M30", "H1 ", "H4 ", "D1 ", "W1 ", "MN1"};
string ArrayInCorrectExchange[100000000];
string ArrayInCorrectMetals[100000000];
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start()
 {
  datetime Market_Info, Mark_Inf, iTimeBegin, timetemp;
  int      a, b, p, h, ee, eee, epp, ejj, eii, mm, mmm, mii, mpp, mjj;
  int      e = 1;
  int      m = 1;
  int      QuestExchE  = IDYES;
  int      QuestCheckE = IDYES;
  int      QuestExchM  = IDYES;
  int      QuestCheckM = IDYES;
  int      size;
  string   infoE, infoM;
  //----
  datetime time[];
  int ArraySizeCurrency = ArraySize (ArrayCurrency);
  int ArraySizeMetals = ArraySize (ArrayMetals);
  int differE = 9 * MathPow (ArraySizeCurrency, 2);
  int differM = 9 * ArraySizeMetals;
  //       . / .
  QuestExchE = MessageBox ("   ?", "  ", MB_YESNO|MB_ICONQUESTION);
  //----
  if (QuestExchE == IDYES)  //  .
   {
    //      ""  . / .
    QuestCheckE = MessageBox ("   \n     ()?", "    !", MB_YESNO|MB_ICONQUESTION);
    for (a = 0; a < ArraySizeCurrency; a++) //   .
     for (b = 0; b < ArraySizeCurrency; b++)
      {
       eii++;
       Market_Info = MarketInfo (ArrayCurrency[a] + ArrayCurrency[b], MODE_TIME);
       if (ArrayCurrency[a] != ArrayCurrency[b] && Market_Info != 0)
        {
         ee++;
         for (p = 0; p <= 8; p++)
          {
           epp++;
           Mark_Inf = Market_Info - 60 * ArrayTimFram_time[p];
           iTimeBegin = iTime (ArrayCurrency[a] + ArrayCurrency[b], ArrayTimFram_time[p], 0);
           while (Mark_Inf < iTimeBegin)
            {
             ejj++;
             size = ArrayCopySeries (time, MODE_TIME, ArrayCurrency[a] + ArrayCurrency[b], ArrayTimFram_time[p]);
             if (GetLastError() == 0) break;
             if (IsStopped() == true)
              {
               ArrayInCorrectExchange[e] = "================================================";
               ArrayInCorrectExchange[e + 1] = "   " + TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
               FileCreate_ArrayString ("ZZ_All_Quotings_Exchange_InCorrect.dat", ArrayInCorrectExchange, 0, e + 2, 0, SEEK_SET);
               return;
              }
            }
           if (QuestCheckE == IDYES) //    "YES"     "".
            {
             for (h = 0; h < size - 1; h++)
              {
               timetemp = (time[h] - time[h + 1]) / 60;
               if ((ArrayTimFram_time[p] != ArrayTimFram_time[7] && ArrayTimFram_time[p] != ArrayTimFram_time[8] && timetemp != ArrayTimFram_time[p] && TimeDayOfWeek (time[h]) != 1 && TimeDayOfWeek (time[h + 1]) != 5) ||
                   (ArrayTimFram_time[p] == ArrayTimFram_time[7] && timetemp != ArrayTimFram_time[7]) ||
                   (ArrayTimFram_time[p] == ArrayTimFram_time[8] && 
                   (((TimeMonth (time[h + 1]) == 1 || TimeMonth (time[h + 1]) == 3 || TimeMonth (time[h + 1]) == 5 || TimeMonth (time[h + 1]) == 7 || TimeMonth (time[h + 1]) == 8 || TimeMonth (time[h + 1]) == 10 || TimeMonth (time[h + 1]) == 12) && timetemp != ArrayTimFram_time[11]) ||
                    ((TimeMonth (time[h + 1]) == 4 || TimeMonth (time[h + 1]) == 6 || TimeMonth (time[h + 1]) == 9 || TimeMonth (time[h + 1]) == 11) && timetemp != ArrayTimFram_time[8]) ||
                    ((MathMod (TimeYear (time[h + 1]), 4) == 0 && TimeMonth (time[h + 1]) == 2 && timetemp != ArrayTimFram_time[10]) || (MathMod (TimeYear (time[h + 1]), 4) != 0 && TimeMonth (time[h + 1]) == 2 && timetemp != ArrayTimFram_time[9])))))
                {
                 if (ee != eee)
                  {
                   ArrayInCorrectExchange[0] = "   " + TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
                   if (ee < 10)  ArrayInCorrectExchange[e] = " " + ee + ".===================" + ArrayCurrency[a] + ArrayCurrency[b] + "====================";
                   if (ee >= 10) ArrayInCorrectExchange[e] = ee + ".===================" + ArrayCurrency[a] + ArrayCurrency[b] + "====================";
                   eee = ee;
                   e++;
                  }
                 ArrayInCorrectExchange[e] = ArrayCurrency[a] + ArrayCurrency[b] + "_" + ArrayTimfram_str[p] + " <" + TimeToStr (time[h + 1], TIME_DATE|TIME_MINUTES) + ">=<" + TimeToStr (time[h], TIME_DATE|TIME_MINUTES) + ">";
                 e++;
                }/**/
               Comment("  ",
                       "\n: ", 100 * (9 * eii - 8 + p) / differE, " %",
                       "\n: ", " ", ee, ". ", ArrayCurrency[a] + ArrayCurrency[b],
                       "\n: ", ArrayTimfram_str[p],
                       "\n  : ", size,
                       "\n  = ", h,
                       "\n  = ", e); 
              }
            }
           else
            {
             Comment("  ",
                     "\n: ", 100 * (9 * eii - 8 + p) / differE, " %",
                     "\n: ", " ", ee, ". ", ArrayCurrency[a] + ArrayCurrency[b],
                     "\n: ", ArrayTimfram_str[p],
                     "\n  : ", size);
            }
          }
        }
      }
     ArrayInCorrectExchange[e + 1] = "=================================================\n   " + TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
     FileCreate_ArrayString ("ZZ_All_Quotings_Exchange_InCorrect.txt", ArrayInCorrectExchange, 0, e, 0, SEEK_SET);
    }
  if (ee != 0 && QuestCheckE == IDYES) infoE = StringConcatenate ("     = ", eii,
                                                                  "\n       = ", ee,
                                                                  "\n     = ", epp,
                                                                  "\n      = ", ejj,
                                                                  "\n    = ", e - ee - 1,
                                                                  "\n   : ...MetaTrader 4.00\experts\files\ZZ_All_Quotings_Exchange_InCorrect.txt");
  else infoE = "";
  //----
  if (ee != 0 && QuestCheckE == IDNO)  infoE = StringConcatenate ("     = ", eii,
                                                                  "\n       = ", ee,
                                                                  "\n     = ", epp,
                                                                  "\n      = ", ejj);
  else infoE = "";
  //===============================================================================================================================================================================
  //      . / .
  QuestExchM = MessageBox ("  ?", " ", MB_YESNO|MB_ICONQUESTION);
  //----
  if (QuestExchM == IDYES)  // .
   {
    //      ""  . / .
    QuestCheckM = MessageBox ("   \n    ()?", "    !", MB_YESNO|MB_ICONQUESTION);
    for (a = 0; a < ArraySizeMetals; a++) //  .
     {
      mii++;
      Market_Info = MarketInfo (ArrayMetals[a], MODE_TIME);
      if (Market_Info != 0)
       {
        mm++;
        for (p = 0; p <= 8; p++)
         {
          mpp++;
          Mark_Inf = Market_Info - 60 * ArrayTimFram_time[p];
          iTimeBegin = iTime (ArrayMetals[a], ArrayTimFram_time[p], 0);
          while (Mark_Inf < iTimeBegin)
           {
            mjj++;
            size = ArrayCopySeries (time, MODE_TIME, ArrayMetals[a], ArrayTimFram_time[p]);
            if (GetLastError() == 0) break;
            if (IsStopped() == true)
             {
              ArrayInCorrectMetals[m] = "================================================";
              ArrayInCorrectMetals[m + 1] = "   " + TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
              FileCreate_ArrayString ("ZZ_All_Quotings_Metals_InCorrect.dat", ArrayInCorrectMetals, 0, m + 2, 0, SEEK_SET);
              return;
             }
           }
          if (QuestCheckM == IDYES) //    "YES"     "".
           {
            for (h = 0; h < size - 1; h++)
             {
              timetemp = (time[h] - time[h + 1]) / 60;
              if ((ArrayTimFram_time[p] != ArrayTimFram_time[7] && ArrayTimFram_time[p] != ArrayTimFram_time[8] && timetemp != ArrayTimFram_time[p] && TimeDayOfWeek (time[h]) != 1 && TimeDayOfWeek (time[h + 1]) != 5) ||
                  (ArrayTimFram_time[p] == ArrayTimFram_time[7] && timetemp != ArrayTimFram_time[7]) ||
                  (ArrayTimFram_time[p] == ArrayTimFram_time[8] && 
                  (((TimeMonth (time[h + 1]) == 1 || TimeMonth (time[h + 1]) == 3 || TimeMonth (time[h + 1]) == 5 || TimeMonth (time[h + 1]) == 7 || TimeMonth (time[h + 1]) == 8 || TimeMonth (time[h + 1]) == 10 || TimeMonth (time[h + 1]) == 12) && timetemp != ArrayTimFram_time[11]) ||
                   ((TimeMonth (time[h + 1]) == 4 || TimeMonth (time[h + 1]) == 6 || TimeMonth (time[h + 1]) == 9 || TimeMonth (time[h + 1]) == 11) && timetemp != ArrayTimFram_time[8]) ||
                   ((MathMod (TimeYear (time[h + 1]), 4) == 0 && TimeMonth (time[h + 1]) == 2 && timetemp != ArrayTimFram_time[10]) || (MathMod (TimeYear (time[h + 1]), 4) != 0 && TimeMonth (time[h + 1]) == 2 && timetemp != ArrayTimFram_time[9])))))
               {
                if (mm != mmm)
                 {
                  ArrayInCorrectMetals[0] = "   " + TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
                  if (mm < 10)  ArrayInCorrectMetals[m] = " " + mm + ".====================" + ArrayMetals[a] + "=====================";
                  if (mm >= 10) ArrayInCorrectMetals[m] = mm + ".====================" + ArrayMetals[a] + "=====================";
                  mmm = mm;
                  m++;
                 }
                ArrayInCorrectMetals[m] = ArrayMetals[a] + "_" + ArrayTimfram_str[p] + " <" + TimeToStr (time[h + 1], TIME_DATE|TIME_MINUTES) + ">=<" + TimeToStr (time[h], TIME_DATE|TIME_MINUTES) + ">";
                m++;
               }
              Comment(" ",
                      "\n: ", 100 * (9 * mii - 8 + p) / differM, " %",
                      "\n: ", " ", mm, ". ", ArrayMetals[a],
                      "\n: ", ArrayTimfram_str[p],
                      "\n  : ", size,
                      "\n  = ", h,
                      "\n  = ", m); 
             } 
           }
          else
           {
            Comment(" ",
                    "\n: ", 100 * (9 * mii - 8 + p) / differM, " %",
                    "\n: ", " ", mm, ". ", ArrayMetals[a],
                    "\n: ", ArrayTimfram_str[p],
                    "\n  : ", size); 
           }
         }
       }
     }
    ArrayInCorrectMetals[m + 1] = "===================================================\n   " + TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS);
    FileCreate_ArrayString ("ZZ_All_Quotings_Metals_InCorrect.txt", ArrayInCorrectMetals, 0, m, 0, SEEK_SET); 
   }
  if (mm != 0 && QuestCheckM == IDYES) infoM = StringConcatenate ("    = ", mii,
                                                                  "\n      = ", mm,
                                                                  "\n    = ", mpp,
                                                                  "\n     = ", mjj,
                                                                  "\n   = ", m - mm - 1,
                                                                  "\n   : ...MetaTrader 4.00\experts\files\ZZ_All_Quotings_Metals_InCorrect.txt");
  else infoM = "";
  //----
  if (mm != 0 && QuestCheckM == IDNO)  infoM = StringConcatenate ("    = ", mii,
                                                                  "\n      = ", mm,
                                                                  "\n    = ", mpp,
                                                                  "\n     = ", mjj);
  else infoM = "";
  //===============================================================================================================================================================================
  Comment (infoE, "\n", "\n", infoM);
  return;
 }
//=================================================================================================================================================================================
//==== "     ".========================================================================================================================
int FileCreate_ArrayString (string Name, string Array[], int start, int count, int offset, int origin)  // ( ;   ;    ;    ;   ;    )
 {
  bool   BL;
  int    Bool;
  int    handle;
//----
  handle = FileOpen (Name, FILE_BIN|FILE_WRITE, ';');
//----
  if (handle == -1)
   {
    Print (" ", Name, "  ,   : ", GetLastError());
    Bool = -1;
    return (false);
   }
  else
   {
    BL = FileSeek (handle, offset, origin);
    Bool = FileWriteArray (handle, Array, start, count);
    if (BL == false) Print ("   ",  Name, "  ,   : ", GetLastError());
    if (Bool == -1) Print ("   ", Name, "  ,   : ", GetLastError());
    FileClose (handle);
   }
  return(Bool);
 }
//=================================================================================================================================================================================